# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 Michael Spencer <spencers1993@gmail.com>
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

from locale import gettext as _

import os, subprocess

from launchpadlib.launchpad import Launchpad
from gi.repository import Gtk

from contributor_console import utils

distro_name = 'ubuntu'

def connect():
	global distro
	
	cachedir = '/home/' + os.getlogin() + '/.launchpadlib/cache'
	launchpad = Launchpad.login_anonymously('contributor-console', 'production', cachedir)
	distro = launchpad.projects[distro_name]

def check_for_package(name):
	return distro.getSourcePackage(name=name) != None

def branch_package(name, folder):
	utils.run('bzr branch %s:%s %s' % (distro_name, name, folder))
	return folder
	
def branch_project(name, folder):
	utils.run('bzr branch lp:%s %s' % (name, folder))
	return folder
