# -*- Mode: Python; coding: utf-8; indent-tabs-mode: nil; tab-width: 4 -*-
### BEGIN LICENSE
# Copyright (C) 2012 Michael Spencer <spencers1993@gmail.com>
# This program is free software: you can redistribute it and/or modify it 
# under the terms of the GNU General Public License version 3, as published 
# by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful, but 
# WITHOUT ANY WARRANTY; without even the implied warranties of 
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR 
# PURPOSE.  See the GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along 
# with this program.  If not, see <http://www.gnu.org/licenses/>.
### END LICENSE

from locale import gettext as _

import cairo

from gi.repository import Gtk, Gdk, Pango, GObject, GdkPixbuf

from contributor_console.buttons import SectionSelector
#from contributor_console.view_pane.globalpane import GlobalPane

class PreferencesPane(Gtk.VBox):
    ICON_SIZE = Gtk.IconSize.LARGE_TOOLBAR
  
    selector_group = None
    
    def __init__(self):
        Gtk.VBox.__init__(self) 
        print 'STARTING CONSTRUCTOR'        
        
        toolbar = Gtk.Toolbar()
        
        self._add_space(toolbar)
        
        self.toolbar = Gtk.HBox()
        self.toolbar.set_homogeneous(True)
        item = Gtk.ToolItem()
        item.add(self.toolbar)
        item.show()
        toolbar.add(item)
        self.toolbar.show()
        
        self._add_space(toolbar)
        
        self.pack_start(toolbar, True, True, 0)
        toolbar.show()
        
        context = toolbar.get_style_context()
        context.add_class(Gtk.STYLE_CLASS_PRIMARY_TOOLBAR)
        
        self.panes = Gtk.VBox()
        self.pack_start(self.panes, True, True, 0)
        self.panes.show()
        print 'IN CONSTRUCTOR'
    
    def _add_space(self, toolbar):
        item = Gtk.SeparatorToolItem()
        item.set_expand(True)
        item.set_draw(False)
        item.show()
        toolbar.add(item)
    
    def add_pane(self, pane, icon, label):
        pane.set_border_width(12)
        button = SectionSelector(label, icon, self.ICON_SIZE)
        self.toolbar.add(button)
        button.show()

        if self.selector_group is not None:
            button.join_group(self.selector_group)

        self.selector_group = button
        
        button.connect('clicked', self._on_paneSelector_clicked)
        self.panes.add(pane)
        self.switch_to_pane(pane)

    def _on_paneSelector_clicked(self, button):
        index = self.toolbar.get_children().index(button)
        pane = self.panes.get_children()[index]
        
        self.button_switch_to_pane(pane)

    # Function based on code taken from Ask Ubuntu answer
    def button_switch_to_pane(self, pane):        
        # hide all pages
        for child in self.panes.get_children():
            child.hide()
        # show the single page that is active
        pane.show()

    # Function based on code taken from Ask Ubuntu answer
    def switch_to_pane(self, pane):        
        self.toolbar.get_children()[self.panes.get_children().index(pane)].set_active(True)
